<?php
/*
	Attachments Gallery
	Display attachments gallery from specified forum(s)
	Adapted by LeeFish from a plug in by RateU at MyBBHacks.
	The author doesn't have responsibility for any harm to your forum that could have been caused by this plugin/mod.
	Use at your own risk.
*/

if(!defined('IN_MYBB'))
{
	die('Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.');
}

function fishhattatgal_2_info()
{
	return array(
		'name'			=> 'Fresh Fish Attachments Gallery',
		'description'	=> 'Fresh Fish Attachments Gallery',
		'website'		=> 'http://www.leefish.nl/mybb/forum-51.html',
		'author'		=> 'RateU',
		'authorsite'	=> 'http://mybbhacks.zingaburga.com/member.php?action=profile&uid=171',
		'version'		=> '1.1',
		'compatibility' => '1*',
	);
}

function fishhattatgal_2_activate()
{
	global $db;
	
	$settinggroups = array(
		'name'			=> 'fishhattatgal_2_title',
		'title'			=> 'Fresh Fish Attachments Gallery',
		'description'	=> 'Settings For Fresh Fish Attachments Gallery',
		'disporder'		=> '99',// My Favorite Number :)
		'isdefault'		=> 'no'
	);
	
	$db->insert_query('settinggroups',$settinggroups);
	$gid = $db->insert_id();
	
	$settings = array(
		'name'			=> 'fishhattatgal_2_ed',
		'title'			=> 'Enable/Disable',
		'description'	=> 'Do you want to enable The Fresh Fish Attachments Gallery?',
		'optionscode'	=> 'yesno',
		'value'			=> '1',
		'disporder'		=> '1',
		'gid'			=> intval($gid)
	);
	$db->insert_query("settings",$settings);

	$settings = array(
		'name'			=> 'fishhattatgal_2_fid',
		'title'			=> 'Forum ID',
		'description'	=> 'Type the forum id(s) for the Fresh Fish Attachments Gallery. Seperate with commas.',
		'optionscode'	=> 'text',
		'value'			=> '2,3',
		'disporder'		=> '2',
		'gid'			=> intval($gid)
	);
	$db->insert_query("settings",$settings);

	$settings = array(
		'name'			=> 'fishhattatgal_2_num',
		'title'			=> 'Number Of Attachments Thumbnails',
		'description'	=> 'How many attachments thumbnails do you want to be displayed?',
		'optionscode'	=> 'text',
		'value'			=> '5',
		'disporder'		=> '3',
		'gid'			=> intval($gid)
	);
	$db->insert_query("settings",$settings);
	
	$settings = array(
		'name'			=> 'fishhattatgal_2_dsp',
		'title'			=> 'Displaying Fresh Fish Attachments Gallery',
		'description'	=> 'Where do you want the Fresh Fish Attachments Gallery to be displayed?',
		'optionscode'	=> 'select
portal=Portal
index=Index
poin=Portal And Index
global=All Pages',
		'value'			=> 'portal',
		'disporder'		=> '4',
		'gid'			=> intval($gid)
	);
	$db->insert_query("settings",$settings);

	$template = array(
		'tid'		=> NULL,
		'title'		=> "fishhatt_2_gallery",
		'template'	=> "<table border=\"0\" cellspacing=\"{\$theme[\'borderwidth\']}\" cellpadding=\"{\$theme[\'tablespace\']}\" class=\"tborder\">
	<tbody>
		<tr>
			<td class=\"thead\">
				<div class=\"expcolimage\">
					<img src=\"{\$theme[\'imgdir\']}/collapse{\$collapsedimg[\'fishhatt_2atgal_2\']}.gif\" id=\"fishhattatgal_2_img\" class=\"expander\" alt=\"[-]\" title=\"\" />
				</div>
				<div><strong>Attachments Gallery</strong></div>
			</td>
		</tr>
	</tbody>
	<tbody style=\"{\$collapsed[\'fishhattatgal_2_e\']}\" id=\"fishhattatgal_2_e\">
		<tr>
			<td class=\"trow1\" align=\"center\">
				{\$fishhatt_2_gallery_gallery}
			</td>
		</tr>
	</tbody>
</table>
<br />",
		'sid'		=> "-1"
	);
	
	$db->insert_query("templates", $template);
	
	$template = array(
		'tid'		=> NULL,
		'title'		=> "fishhatt_2_gallery_gallery",
		'template'	=> "<a href=\"{\$fishhatt_postlink}\"><img src=\"{\$fishhatt_att_thumb}\" alt=\"{\$fishhatt_title}\" title=\"{\$fishhatt_title}, Posted By: {\$fishhatt_username} Uploaded At: {\$fishhatt_datetime}\" class=\"attachment\" style=\"vertical-align: middle\" /></a>",
		'sid'		=> "-1"
	);
	$db->insert_query("templates", $template);
	rebuild_settings();
	
	require MYBB_ROOT.'/inc/adminfunctions_templates.php';
	find_replace_templatesets('header', '#^(.*)$#s', "\\1\r\n" . '<!-- Attachment Gallery -->');
}

function fishhattatgal_2_deactivate()
{
	global $db;

	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='fishhatt_2_gallery'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='fishhatt_2_gallery_gallery'");
	$db->query('DELETE FROM '.TABLE_PREFIX.'settinggroups WHERE name=\'fishhattatgal_2_title\'');
	$db->query('DELETE FROM '.TABLE_PREFIX.'settings WHERE name IN(
		\'fishhattatgal_2_ed\',
		\'fishhattatgal_2_fid\',
		\'fishhattatgal_2_num\',
		\'fishhattatgal_2_dsp\'
	)');
	rebuild_settings();
	
	require MYBB_ROOT.'/inc/adminfunctions_templates.php';
	find_replace_templatesets('header', '#<!-- Attachment Gallery -->#', '', 0);
}

$plugins->add_hook('global_start', 'fishhattatgal_2_tcache');
function fishhattatgal_2_tcache()
{
	if(isset($GLOBALS['templatelist']))
	{
		$GLOBALS['templatelist'] .= ',fishhatt_2_gallery,fishhatt_2_gallery_gallery';
	}

	if($GLOBALS['mybb']->settings['fishhattatgal_2_dsp'] == 'portal')
	{
		$GLOBALS['plugins']->add_hook('portal_start', 'fishhattatgal_2_run');
	}
	elseif($GLOBALS['mybb']->settings['fishhattatgal_2_dsp'] == 'index')
	{
		$GLOBALS['plugins']->add_hook('index_end', 'fishhattatgal_2_run');
	}
	elseif($GLOBALS['mybb']->settings['fishhattatgal_2_dsp'] == 'poin')
	{
		$GLOBALS['plugins']->add_hook('index_end', 'fishhattatgal_2_run');
		$GLOBALS['plugins']->add_hook('portal_start', 'fishhattatgal_2_run');
	}
	else
	{
		$GLOBALS['plugins']->add_hook('global_end', 'fishhattatgal_2_run');
	}
}

function fishhattatgal_2_run()
{
    global $mybb, $db, $collapsed, $collapsedimg, $templates, $theme, $forum, $fishhattachment_gallery2;

	
	if($mybb->settings['fishhattatgal_2_ed'] != 0)
	{
			$days = 7;
		
		$cutoff = TIME_NOW - (60 * 60 * 24 * $days);
		
		$unviewableforums = get_unviewable_forums(true);
		$fidnot = '';
		if($unviewableforums)
		{
			$fidnot = "AND th.fid NOT IN ($unviewableforums)";
		}
		
		$fishhattatgal_2_num = intval($mybb->settings['fishhattatgal_2_num']);
		if(is_array(explode(',', $mybb->settings['fishhattatgal_2_fid'])))
		{
			foreach(explode(',', $mybb->settings['fishhattatgal_2_fid']) as $fishhattatgal_2_tid)
			{
				$fishhattatgal_2_tid_array[] = intval($fishhattatgal_2_tid);
			}
		}
		
		$query = $db->query("SELECT a.*, f.name, th.closed, th.username, th.tid, th.fid, th.replies, th.subject, p.visible, count( p.pid ) AS replies
							FROM ".TABLE_PREFIX."threads th
							INNER JOIN ".TABLE_PREFIX."posts p ON th.tid = p.tid
							INNER JOIN ".TABLE_PREFIX."forums f ON th.fid=f.fid
							INNER JOIN ".TABLE_PREFIX."xtattachments a ON th.tid=a.tid
							WHERE p.dateline >= {$cutoff} {$fidnot} AND p.pid!=th.firstpost AND p.visible=1 AND th.replies>0 AND a.thumbs!=' ' AND th.closed NOT LIKE 'moved|%' AND th.fid IN ('".implode("','", $fishhattatgal_2_tid_array)."')
							GROUP BY p.tid
							ORDER BY replies DESC 
							LIMIT $fishhattatgal_2_num
							");
							
		while($fishhatt = $db->fetch_array($query))
		{
			$fishhatt_username = htmlspecialchars_uni($fishhatt['username']);
			$fishhatt_views = number_format($fishhatt['recentviews']);
			$fishhatt_replies = number_format($fishhatt['replies']);
			$fishhatt_forumname = htmlspecialchars_uni($fishhatt['name']);
			$fishhatt_title = htmlspecialchars_uni($fishhatt['subject']);
			$fishhatt_postlink = get_thread_link(intval($fishhatt['tid']));
			$fishhatt_forumlink = get_forum_link(intval($fishhatt['fid']));
			$fishhatt_datetime = my_date($mybb->settings['dateformat'], $fishhatt['uploadtime']).' '.my_date($mybb->settings['timeformat'], $fishhatt['uploadtime']);
			$fishhatt_att_thumb = xthreads_get_xta_url($fishhatt).'/thumbindexthumb';
			eval("\$fishhatt_2_gallery_gallery .= \"".$templates->get("fishhatt_2_gallery_gallery")."\";");
		}
		eval("\$fishhattachment_gallery2 = \"".$templates->get("fishhatt_2_gallery")."\";");
	}
}
?>